<?php
namespace app\index\controller;
use think\Controller;
use think\Db;
use think\Request;
class TbSf6env extends Controller 
{
	public function index() 
	{
		$edate=date("Y-m-d");
		$sdate=date('Y-m-d',strtotime("$edate -1 month"));
                           //     alert("tbsf6env: " + date);
		if (!empty($_GET['stime'])) 
		{
			$sdate=$_GET['stime'];
		}
		if (!empty($_GET['etime'])) 
		{
			$edate=substr($_GET['etime'],0,10);
			$edate=date("Y-m-d",strtotime("$edate +1 day"));
		}
		if (empty($_GET['id'])) die('无效的编号');
		$id = $_GET['id'];
		$warn=Db::table('warn_cfg')->where('eqmid',$id)->find();
		session('warn',$warn);
		$this->assign('warn',$warn);
		$data = Db::table('data_sf6env_h')->field('d_time,gas1,yq1,md1,pm1,gas2,yq2,md2,pm2,gas3,yq3,md3,pm3')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->order('d_time desc')->paginate(10,false,['query'=>request()->param(),]);
		$data1 = Db::table('data_sf6env_h')->field('d_time,gas1,yq1,md1,pm1,gas2,yq2,md2,pm2,gas3,yq3,md3,pm3')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->select();
		session('data',$data);
		session('data1',$data1);
		$this->assign('data',$data);
		return $this->fetch('tb_sf6env');
	}
	public function ExcelOne() 
	{
		$list = session('data');
		$xlsCell = array( array('d_time','时间'), array('gas1','A相SF6浓度'), array('yq1','A相O2含量'), array('md1','A相温度'), array('pm1','A相湿度'),  array('gas2','B相SF6浓度'), array('yq2','B相O2含量'), array('md2','B相温度'), array('pm2','B相湿度'), array('gas3','C相SF6浓度'), array('yq3','C相O2含量'), array('md3','C相温度'), array('pm3','C相湿度') );
		$this->exportExcel("当前数据导出",$xlsCell,$list);
	}
	public function ExcelAll() 
	{
		$list = session('data1');
		$xlsCell = array( array('d_time','时间'), array('gas1','A相SF6浓度'), array('yq1','A相O2含量'), array('md1','A相温度'), array('pm1','A相湿度'),  array('gas2','B相SF6浓度'), array('yq2','B相O2含量'), array('md2','B相温度'), array('pm2','B相湿度'), array('gas3','C相SF6浓度'), array('yq3','C相O2含量'), array('md3','C相温度'), array('pm3','C相湿度') );
		$this->exportExcel("全部数据导出",$xlsCell,$list);
	}
	public function exportExcel($expTitle,$expCellName,$expTableData) 
	{
		$xlsTitle = iconv('utf-8','gb2312',$expTitle);
		$fileName = $expTitle.date('_YmdHis');
		$cellNum = count($expCellName);
		$dataNum = count($expTableData);
		import('PhpExcel',EXTEND_PATH);
		$objPHPExcel = new \PhpExcel();
		$objWriter = new \PHPExcel_Writer_Excel5($objPHPExcel);
		$cellName = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ');
		$objPHPExcel->getActiveSheet(0)->mergeCells('A1:'.$cellName[$cellNum-1].'1');
		for($i=0;$i<$cellNum;$i++)
		{
			$objPHPExcel->getActiveSheet(0)->getColumnDimension($cellName[$i])->setWidth(18);
			$objPHPExcel->setActiveSheetIndex(0)->setCellValue($cellName[$i].'2',$expCellName[$i][1]);
		}
		for($i=0;$i<$dataNum;$i++)
		{
			for($j=0;$j<$cellNum;$j++)
			{
				if($expTableData[$i]['gas1']<session('warn.warnmin1') ||$expTableData[$i]['gas1']>session('warn.warnmax1'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('B'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['yq1']<session('warn.warnmin2') ||$expTableData[$i]['yq1']>session('warn.warnmax2'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('C'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['md1']<session('warn.warnmin3') ||$expTableData[$i]['md1']>session('warn.warnmax3'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('D'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['pm1']<session('warn.warnmin4') ||$expTableData[$i]['pm1']>session('warn.warnmax4'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('E'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				
				if($expTableData[$i]['gas2']<session('warn.warnmin5') ||$expTableData[$i]['gas2']>session('warn.warnmax5'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('G'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['yq2']<session('warn.warnmin6') ||$expTableData[$i]['yq2']>session('warn.warnmax6'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('H'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['md2']<session('warn.warnmin7') ||$expTableData[$i]['md2']>session('warn.warnmax7'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('I'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['pm2']<session('warn.warnmin8') ||$expTableData[$i]['pm2']>session('warn.warnmax8'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('J'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				
                                
				if($expTableData[$i]['gas3']<session('warn.warnmin9') ||$expTableData[$i]['gas3']>session('warn.warnmax9'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('L'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['yq3']<session('warn.warnmin10') ||$expTableData[$i]['yq3']>session('warn.warnmax10'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('M'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['md3']<session('warn.warnmin11') ||$expTableData[$i]['md3']>session('warn.warnmax11'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('N'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				if($expTableData[$i]['pm3']<session('warn.warnmin12') ||$expTableData[$i]['pm3']>session('warn.warnmax12'))
				{
					$objPHPExcel->getActiveSheet(0)->getStyle('O'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
				}
				
				$objPHPExcel->getActiveSheet(0)->setCellValue($cellName[$j].($i+3),$expTableData[$i][$expCellName[$j][0]]);
			}
		}
		header('Content-Type: application/vnd.ms-excel');
		header('Content-Disposition: attachment;filename="'.$xlsTitle.'.xls"');
		header('Cache-Control: max-age=0');
		$objWriter->save('php://output');
		exit;
	}
}
?>
